Subject: Re: RFC 2596 questions

From: "Jim Sermersheim" <[email-masked]>
Date: Thu, 21 Sep 2000 12:33:35 -0600

>>>> Mark Wahl <[email-masked]> 9/18/00 5:20:21 PM >>>

>> Is that correct? If so, I believe the following assumption is also correct:
>> Any value held in an attribute with more than one language option (i.e. the 
>> example above) does NOT exist in the attribute with a subset of those 
>> language options. In other words, the example above does NOT imply that 
>> there are values like:
>> cn;lang-en-US: JoeBob
>> cn;lang-ja: JoeBob
>> Right?
>
>Those are different values.  You could have them there as well, if you wished.

I worded that poorly. What I meant to say, is that given the entry:

dn: cn=JoeBob,o=myorg
cn:lang-en-US: Joe
cn;lang-ja: Bob

cn;lang-en-US;lang-ja: JoeBob

The search filter (cn;lang-en = JoeBob) will NOT match. This is due to the fact that as stated in RFC 2251, "An AttributeDescription with one or more options is treated as a subtype of the attribute type without any options".

This statement tells me that 
cn:lang-en-US is a direct subtype of cn
cn;lang-ja is a direct subtype of cn
cn;lang-en-US;lang-ja is a direct subtype of cn.

Yes, I'm reading "direct" into the 2251 statement. David has argued that:
cn;lang-en-US;lang-ja is a direct subtype of cn;lang-en-US, which in turn is a direct subtype of cn. Does this also mean that it's also a subtype of cn;lang-ja, or is it strictly a right to left thing? If r to l, then the attribute type option ordering restriction will get in people's way.

Jim

---

From: "David Chadwick" <[email-masked]>
Date: Sat, 23 Sep 2000 12:11:55 +0100

> Yes, I'm reading "direct" into the 2251 statement. David has argued
> that: cn;lang-en-US;lang-ja is a direct subtype of cn;lang-en-US,
> which in turn is a direct subtype of cn. Does this also mean that it's
> also a subtype of cn;lang-ja, 

Yes, I would say so. The new dual language subtype is a subtype 
of both single language subtypes. The order does not matter. We 
have

               supertype
             /                  \
subtype 1                    subtype 2
              \                 /
              subtype1-2

David

>or is it strictly a right to left thing?
> If r to l, then the attribute type option ordering restriction will
> get in people's way.
> 
> Jim
> 

***************************************************

David Chadwick
IS Institute, University of Salford, Salford M5 4WT
Tel +44 161 295 5351  Fax +44 161 745 8169
Mobile +44 790 167 0359
Email [email-masked]
Home Page  http://www.salford.ac.uk/its024/chadwick.htm
Understanding X.500  http://www.salford.ac.uk/its024/X500.htm
X.500/LDAP Seminars http://www.salford.ac.uk/its024/seminars.htm
Entrust key validation string MLJ9-DU5T-HV8J

***************************************************

---

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Sat, 23 Sep 2000 12:24:51 -0700

At 12:11 PM 9/23/00 +0100, David Chadwick wrote:
>> Yes, I'm reading "direct" into the 2251 statement.

So did I.  I did this also because of the specification of Attribute
Type Description in RFC 2252.  RFC2252 says that the NAME can
be an attribute description but only one SUPer type can be listed.
This implies that each attribute description has only one direct
super type (the attribute type without any options).

However, it seems that this is never used and conflicts with
common (and RFC2596) usage:  requesting "name;option" returns not
only name;option but also all subtypes (direct or indirect) of name
which have (or support) this option.  That is  "name;binary" requests
"name;binary" as well as "cn;binary", "sn;binary", etc.

>David has argued

So (to clarify):

attr;a;b;c is a subtype of attr;a;b, attr;a;c, attr;b;c.
attr;a;b is a subtype of attr;a and attr;b
attr;a;c is a subtype of attr;a and attr;c
attr;b;c is a subtype of attr;b and attr;c
attr;a is a subtype of attr
attr;b is a subtype of attr
attr;c is a subtype of attr

And if:

attr is a subtype of super, then

attr;a;b;c is a subtype of super;a;b;c
...

If we had a entry containing attr and super with all combinations
of options a, b, and c; a request for super;a would return:
        super;a super;a;b super;a;b;c
        attr;a; attr;a;b attr;a;b;c

I would agree that RFC 2251 and RFC 2252 needs clarification in
this area.  I've cc'ed LDAPbis mailing list.

Kurt

---

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Sat, 23 Sep 2000 12:29:39 -0700

>        super;a super;a;b super;a;b;c

                and super;a,c

>        attr;a attr;a;b attr;a;b;c

                and attr;a;c